URLDecoder

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.net
Class URLDecoder

    java.lang.Object
      java.net.URLDecoder

    public class URLDecoder

extends Object

Utility class for HTML form decoding. This class contains static methods for decoding a String from the `application/x-www-form-urlencoded` MIME format.

To conversion process is the reverse of that used by the URLEncoder class. It is assumed that all characters in the encoded string are one of the following: "`a`" through "`z`", "`A`" through "`Z`", "`0`" through "`9`", and "`-`", "`_`", "`.`", and "`*`". The character "`%`" is allowed but is interpreted as the start of a special escaped sequence.

The following rules are applied in the conversion:

- The alphanumeric characters "`a`" through "`z`", "`A`" through "`Z`" and "`0`" through "`9`" remain the same.
- The special characters "`.`", "`-`", "`*`", and "`_`" remain the same.
- The plus sign "`+`" is converted into a space character "`` " .
- A sequence of the form "`%xy`" will be treated as representing a byte where xy is the two-digit hexadecimal representation of the 8 bits. Then, all substrings that contain one or more of these byte sequences consecutively will be replaced by the character(s) whose encoding would result in those consecutive bytes. The encoding scheme used to decode these characters may be specified, or if unspecified, the default encoding of the platform will be used.

There are two possible ways in which this decoder could deal with illegal strings. It could either leave illegal characters alone or it could throw an ``IllegalArgumentException``. Which approach the decoder takes is left to the implementation.

Since:
  1.2
Version:
  1.9, 02/02/00
Author:
  Mark Chamness, Michael McCloskey

Constructor Summary
`URLDecoder()`

Method Summary
`static String` | `decode(String s)` Deprecated. The resulting string may vary depending on the platform's default encoding. Instead, use the decode(String,String) method to specify the encoding.
`static String` | `decode(String s, String enc)` Decodes a `application/x-www-form-urlencoded` string using a specific encoding scheme.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### URLDecoder

    public URLDecoder()

Method Detail

### decode

    public static String decode(String s)

  Deprecated. The resulting string may vary depending on the platform's default encoding. Instead, use the decode(String,String) method to specify the encoding.

  Decodes a `x-www-form-urlencoded` string. The platform's default encoding is used to determine what characters are represented by any consecutive sequences of the form "`%xy`".

  Parameters:
    `s` - the `String` to decode
  Returns:
    the newly decoded `String`

### decode

    public static String decode(String s,
                                String enc)
                         throws UnsupportedEncodingException

  Decodes a `application/x-www-form-urlencoded` string using a specific encoding scheme. The supplied encoding is used to determine what characters are represented by any consecutive sequences of the form "`%xy`".

  Note: The World Wide Web Consortium Recommendation states that UTF-8 should be used. Not doing so may introduce incompatibilites.

  Parameters:
    `s` - the `String` to decode
    `enc` - The name of a supported character encoding.
  Returns:
    the newly decoded `String`
  Throws:
    `UnsupportedEncodingException` - If the named encoding is not supported
  Since:
    1.4
  See Also:
    `URLEncoder.encode(java.lang.String, java.lang.String)`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD